.include "tn15def.inc" 
.def tmp =r23		; 
.def state =r24     ;      
.def sl =r25     	;       
.def step = r26     ;  

.cseg				; 
.org 0
rjmp Reset          ; 
rjmp INT_0
rjmp PIN_I
rjmp Timer1_capt1
rjmp Timer1_comp1
rjmp Timer1_OVF1
rjmp Timer0_OVF0
rjmp UART_RX
rjmp UART_UDRE
rjmp UART_TX
rjmp ANA_COMP

//Reset:
//INT_0:
PIN_I:
Timer1_capt1:
Timer1_comp1:
Timer1_OVF1:
Timer0_OVF0:
UART_RX:
UART_UDRE:
UART_TX:
ANA_COMP:
reti

Reset:				
	ldi step,4			;   = 4
//    .
	ldi tmp,0b00000110	;pb1 -  
	out ddrb,tmp			
	ldi tmp,0b00000100	;pb2 - ,    
	out portb,tmp
// 
	ldi tmp,0b01000000	;  
	out GIMSK,tmp
//   
//     2   
//  -  ,      
//       sleep
	ldi tmp,0b00110000
	out MCUCR,tmp
	ldi tmp,0b11111111	;       B
	out OCR1B, tmp
	ldi state,0			;  - 0
	ldi sl,1			;       

// 
loop:
//     
	cpi state,0
	breq start		;
	cpi state,2
	breq to3		; 
	cpi state,3		
	breq to4		; 
	sbic pinb,2		; .    -   
rjmp loop
//     
	cpi state,1
	breq increase	; 
	cpi state,4
	breq decrease	; 
	nop
rjmp loop			;

st_on:				;   1
	ldi state,1
rjmp loop

start:					;
	cli					; 
	ldi tmp,0b01100101	; 
	out TCCR1, tmp
start_step:				;  
	cpi sl,20			;      20
	brsh st_on			;    
	add sl,step			;    
	out OCR1A, sl		;   
	rcall delay			;
rjmp start_step			; 

is_on:	
	sbi portb,1 		;    
	ldi tmp,0b00000000	; 
	out TCCR1, tmp
is_al_on:				;   2
	ldi state,2			
rjmp loop

increase:				;  
	cli
	ldi tmp,0b01100101	; 
	out TCCR1, tmp
inc_step:				;  
	sbic pinb,2			; .    - 
	rjmp is_al_on		
	cpi sl,250			;      250			
	brsh is_on			;   
	add sl,step			;    
	out OCR1A, sl		;   
	rcall delay			;
rjmp inc_step

to3:
	sbic pinb,2			; .    -    3
	ldi state,3
rjmp loop	

to4:
	sbis pinb,2			; .    -    4
	ldi state,4
rjmp loop	 

is_off:					;
	cbi portb,1 		; 
	ldi tmp,0b00000000	; 
	out TCCR1, tmp
	sei					; 
	sleep				; 
	cli					; 
rjmp loop

decrease:				;  
	ldi tmp,0b01100101	; 
	out TCCR1, tmp
dec_step:				;  
	cpi sl,5			;      5
	brlo is_off			;  
	sub sl,step			;    
	out OCR1A, sl		;   
	rcall delay			;
rjmp dec_step

//      2  
INT_0:			
	ldi state, 0 ;C = 0
	cli
reti

//
delay:
        ldi r17,50 
l:      ldi r18,255             			
l1:     dec r18                 
        brne l1                 
        dec r17                 
        brne l                  
        ret
//
.EXIT			
